namespace java com.javacodegeeks.library

service Library {
  void addBook(1: Book book),
  list<Book> getBooks(1: Filter filter),
  bool removeBook(1: string isbn),
  Book updateBook(1: string isbn, 2: Book book)
}

struct Book {
  1: string title, 
  2: string isbn,
  3: optional i32 year
}

struct Filter {
  1: optional i32 year;
  2: optional string title;
  3: optional string isbn;
}
